#include "stdafx.h"
#include "NToolTip.h"
#include "RootContainer.h"

CNToolTip::CNToolTip()
{
	::SetRectEmpty(&m_rcMargin);
	::ZeroMemory(&m_Info, sizeof(TOOLINFO));
	::ZeroMemory(&m_ptTrack, sizeof(POINT));
	_tcscpy(m_szText, _T(""));
	m_bVisible = FALSE;
	m_pDelegate = NULL;
	m_pOwner = NULL;
	m_ptOffset.x = 0;
	m_ptOffset.y = 0;
}

CNToolTip::~CNToolTip()
{

}

void CNToolTip::SetMargin( LPRECT prcMargin )
{	
	// {kr} Է° ȿ ˻ {/kr}
	ATLASSERT(prcMargin != NULL);
	if(!(prcMargin != NULL)) return;

	// {kr}  ſ     . {/kr}
	BOOL bResult = ::EqualRect(&m_rcMargin, prcMargin);
	if (bResult == TRUE) return;

	// {kr} prcMargin(=)   . {/kr}
	::CopyRect(&m_rcMargin, prcMargin);

	// {kr} Ŵ ҷ {/kr}
	CNToolTipMgr* pMgr = this->_LoadToolTipMgr();
	// {kr} Ŵ   ٷ  {/kr}
	if (pMgr == NULL) return;
	
	// {kr} Ŵ   {/kr}
	pMgr->SetMargin(prcMargin);
	// {kr}  ġ Ʈ.(=_UpdatePosition) {/kr}
	this->_UpdatePosition();
}

void CNToolTip::GetMargin( OUT LPRECT prcMargin )
{
	// {kr} Է° ȿ ˻ {/kr}
	ATLASSERT(prcMargin != NULL);
	if(!(prcMargin != NULL)) return;

	::CopyRect(&m_rcMargin, prcMargin);
}

void CNToolTip::SetDelegate( IToolTipDelegate* pDelegate )
{
	// {kr} Է° ȿ ˻ {/kr}
	ATLASSERT(pDelegate != NULL);
	if(!(pDelegate != NULL)) return;

	// {kr} Է° Ű  ٷ  {/kr}
	if (pDelegate == m_pDelegate) return;

	m_pDelegate = pDelegate;

	// {kr}  ؽƮ Ʈ. {/kr}
	this->Update();
}

void CNToolTip::SetVisible(BOOL bVisible)
{
	// {kr} νϽ visible ° ſ 簪 ٸٸ. {/kr}
	if (m_bVisible != bVisible)
	{
		// {kr} visible ° . {/kr}
		m_bVisible = bVisible;
		
		// {kr}  ؽƮ Ʈ. {/kr}
		this->Update();
	}
}

BOOL CNToolTip::IsVisible()
{
	// {kr} ϵ visible ° . {/kr}
	return m_bVisible;
}

void CNToolTip::SetOwner( CComponent* pOwner )
{
	// {kr} Է° ȿ ˻ {/kr}
	ATLASSERT(IS_KIND_OF(CComponent, pOwner) == TRUE);
	if(!(IS_KIND_OF(CComponent, pOwner) == TRUE)) return;

	// {kr} θƮ  . {/kr}
	m_pOwner = pOwner;
}

void CNToolTip::SetText( LPCTSTR szText )
{
	// {kr} Է° ȿ ˻ {/kr}
	ATLASSERT(_tcslen(szText) >= 0);
	if(!(_tcslen(szText) >= 0)) return;

	// {kr} ſ  ؽƮ  ٸ {/kr}
	if (_tcscmp(m_szText, szText) != 0)
	{
		// {kr} ؽƮ . {/kr}
		_tcscpy(m_szText, szText);
		
		// {kr}  ؽƮ Ʈ. {/kr}
		this->Update();
	}
}

CNToolTipMgr* CNToolTip::_LoadToolTipMgr()
{
	// {kr} θƮ ȿѰ ƴϸ   {/kr}
	if(IS_KIND_OF(CComponent, m_pOwner) == FALSE) return NULL;
	
	// {kr} ̽찡 ̸  . {/kr}
	CRootContainer* pRootContainer = m_pOwner->GetRootContainer();
	if (pRootContainer == NULL) return NULL;

	// {kr} Ŵ   {/kr}
	CNToolTipMgr* pMgr = pRootContainer->GetToolTipMgr();
	return pMgr;
}

void CNToolTip::_UpdatePosition()
{
	// {kr} Ŵ ҷ {/kr}
	CNToolTipMgr* pMgr = this->_LoadToolTipMgr();
	// {kr} Ŵ   ٷ  {/kr}
	if (pMgr == NULL) return;
	
	// {kr} Ʈ   ٷ  {/kr}
	if (m_pOwner == NULL) return;

	// {kr}  Ʈ left-top position ϱ {/kr}
	POINT ptOrg = {0, 0};
	m_pOwner->GetParentAbsolutePosition(&ptOrg);

	CRect rcBound;
	m_pOwner->GetBounds(&rcBound);
	ptOrg.x += rcBound.left;
	ptOrg.y += rcBound.top;

	// {kr}  Ʈ ٿ left-top ǥ α׷ǥ ȯ {/kr}
	m_pOwner->ClientToScreen(&ptOrg);
	
	// {kr}  ǥ νϽ   . {/kr}
	ptOrg.x += m_ptOffset.x;
	ptOrg.y += m_ptOffset.y;
	
	// {kr}  ǥ  Ʈ. {/kr}
	pMgr->SetPosition(&ptOrg);
}

void CNToolTip::SetPosition( LPPOINT ppt )
{
	// {kr} Է° ȿ ˻ {/kr}
	ATLASSERT(ppt != NULL);
	if(!(ppt != NULL)) return;

	// {kr} Է° Ű  ٷ  {/kr}
	if (ppt->x == m_ptOffset.x &&
		ppt->y == m_ptOffset.y)
	{
		return;
	}

	// {kr}  ġ Ʈ      ߻ {/kr}
	CRect rcClient;
	m_pOwner->GetClientRect(&rcClient);
	BOOL bOverClient = rcClient.PtInRect(*ppt);
	ATLASSERT(bOverClient == FALSE);
	if(bOverClient == TRUE) return;

	::CopyMemory(&m_ptOffset, ppt, sizeof(POINT));
	
	// {kr}  ؽƮ Ʈ. {/kr}
	this->Update();
}

void CNToolTip::Update()
{/*
	// {kr} Ŵ ҷ. {/kr}
	CNToolTipMgr* pMgr = this->_LoadToolTipMgr();
	if (pMgr == NULL) return;

	// {kr}  ̴ ϶ {/kr}
	if (m_bVisible == TRUE)
	{
		// {kr} Ŵ νϽ  Է. {/kr}
		// {kr} Ŵ ûϿ   Է {/kr}
		pMgr->SetMargin(&m_rcMargin);

		// {kr} 븮ڰ  {/kr}
		if (m_pDelegate != NULL)
		{
			// {kr} 븮ڷ  ؽƮ о鿩  . {/kr}
			m_pDelegate->GetToolTipText(m_szText);
		}
		// {kr}  ϵ ؽƮ Ŵ  쿡 ݿ. {/kr}
		pMgr->SetText(m_szText);

		// {kr}  Ÿ ġ Ͽ Ÿ. {/kr}
		this->_UpdatePosition();
	}

	// {kr} Ŵ ûϿ  visible . {/kr}
	pMgr->SetVisible(this, m_bVisible);

	// {kr} Ŵ ûϿ Ʈ. {/kr}
	pMgr->Update();*/
}